#ifndef BEZIER_PROGRAM_H
#define BEZIER_PROGRAM_H

#include <GL/glew.h>

class BezierProgram{
public:
    void Initialize(const char* vertex_shader_file,
                    const char* fragment_shader_file,
                    const char* geometry_shader_file);
    GLuint GetLineProgram() const{return line_program_;}
    GLuint GetBezierProgram() const{return bezier_program_;}
    ~BezierProgram();
private:
    GLuint line_program_;
    GLuint bezier_program_;

    GLuint vertex_shader_;
    GLuint fragment_shader_;
    GLuint geometry_shader_;

    GLuint LoadAndCompileShaderOrDie(const char* source_file, GLenum type);
    GLuint LinkProgramOrDie(GLint vertex_shader, GLint fragment_shader, GLint geometry_shader = 0);
};

#endif // BEZIER_PROGRAM_H
