#ifndef WINDOW_H
#define WINDOW_H

#include<GL/glew.h>
#include<GLFW/glfw3.h>

#include "bezier.h"
#include "bezierprogram.h"

class Window{
 public:
    Window(const char*, int, int);
    void Initialize(int major_gl_version, int minor_gl_version);
    void KeyEvent(int key, int scancode, int action, int mods);
    void Resize(int new_width, int new_height);
    void MouseButton(int button, int action, int mods);
    void Run(void);
    operator GLFWwindow*(){return window_;}
 private:
    GLFWwindow* window_;
    int width_;
    int height_;
    const char* title_;
    Bezier bezier_;
    BezierProgram bezier_program_;

    void InitGlfwOrDie(int major_gl_version, int minor_gl_version);
    void InitGlewOrDie();
    void InitModels();
    void InitPrograms();

};


#endif // WINDOW_H

